clc
clear all
close all

A = load('Dat/wgstack.txt');
A = A/sqrt(sum(sum(A.*A)));

A = A(1:350,1:275);
s = size(A);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Original Image

figure('units','normalized','outerposition',[0 0 1 1])
scale = [-0.004 0.004];

subplot(1,1,1),subimage(A,scale);
xlabel('Kilometers','FontSize',14,'FontWeight','normal');
ylabel('Time (Seconds)','FontSize',14,'FontWeight','normal');
ax = gca();
set(ax,'XTick',[50 100 150 200 250])
set(ax,'YTick',[50 100 150 200 250 300])
xticklabel = [50 100 150 200 250]*.0335;
yticklabel = [50 100 150 200 250 300]*.004;
set(ax,'XTickLabel',sprintf('%1.2f|',xticklabel),'FontSize',12,'FontWeight','normal')
set(ax,'YTickLabel',sprintf('%1.2f|',yticklabel),'FontSize',12,'FontWeight','normal')

dlmwrite('Dat/wgstack-2DPEF.txt',A,'delimiter','\t','precision',3)

%pause;
close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Path 1
[path,discont] = generate_2D_path(s,1);
order = [5 5];
box = [15 15];
gamma = 0.02;
[output,res,status] = streaming_AR_2D_path(A,order,box,path,discont,gamma);
res = res*3;

figure('units','normalized','outerposition',[0 0 1 1])
scale = [-0.004 0.004];

subplot(1,1,1), subimage(res,scale);
xlabel('Kilometers','FontSize',14,'FontWeight','normal');
ylabel('Time (Seconds)','FontSize',14,'FontWeight','normal');
ax = gca();
set(ax,'XTick',[50 100 150 200 250])
set(ax,'YTick',[50 100 150 200 250 300])
xticklabel = [50 100 150 200 250]*.0335;
yticklabel = [50 100 150 200 250 300]*.004;
set(ax,'XTickLabel',sprintf('%1.2f|',xticklabel),'FontSize',12,'FontWeight','normal')
set(ax,'YTickLabel',sprintf('%1.2f|',yticklabel),'FontSize',12,'FontWeight','normal')

dlmwrite('Dat/wgPEF1.txt',res,'delimiter','\t','precision',3)

%pause;
close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Path 2
[path,discont] = generate_2D_path(s,2);
order = [5 5];
box = [15 15];
gamma = 0.02;
[output,res,status] = streaming_AR_2D_path(A,order,box,path,discont,gamma);
res = res*3;

figure('units','normalized','outerposition',[0 0 1 1])
scale = [-0.004 0.004];

subplot(1,1,1), subimage(res,scale);
xlabel('Kilometers','FontSize',14,'FontWeight','normal');
ylabel('Time (Seconds)','FontSize',14,'FontWeight','normal');
ax = gca();
set(ax,'XTick',[50 100 150 200 250])
set(ax,'YTick',[50 100 150 200 250 300])
xticklabel = [50 100 150 200 250]*.0335;
yticklabel = [50 100 150 200 250 300]*.004;
set(ax,'XTickLabel',sprintf('%1.2f|',xticklabel),'FontSize',12,'FontWeight','normal')
set(ax,'YTickLabel',sprintf('%1.2f|',yticklabel),'FontSize',12,'FontWeight','normal')

dlmwrite('Dat/wgPEF2.txt',res,'delimiter','\t','precision',3)

%pause;
close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Path 11
[path,discont] = generate_2D_path(s,11);
order = [5 5];
box = [15 15];
gamma = 0.02;
[output,res,status] = streaming_AR_2D_path(A,order,box,path,discont,gamma);
res = res*3;

figure('units','normalized','outerposition',[0 0 1 1])
scale = [-0.004 0.004];

subplot(1,1,1), subimage(res,scale);
xlabel('Kilometers','FontSize',14,'FontWeight','normal');
ylabel('Time (Seconds)','FontSize',14,'FontWeight','normal');
ax = gca();
set(ax,'XTick',[50 100 150 200 250])
set(ax,'YTick',[50 100 150 200 250 300])
xticklabel = [50 100 150 200 250]*.0335;
yticklabel = [50 100 150 200 250 300]*.004;
set(ax,'XTickLabel',sprintf('%1.2f|',xticklabel),'FontSize',12,'FontWeight','normal')
set(ax,'YTickLabel',sprintf('%1.2f|',yticklabel),'FontSize',12,'FontWeight','normal')

dlmwrite('Dat/wgPEF11.txt',res,'delimiter','\t','precision',3)

%pause;
close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Path 12
[path,discont] = generate_2D_path(s,12);
order = [5 5];
box = [15 15];
gamma = 0.02;
[output,res,status] = streaming_AR_2D_path(A,order,box,path,discont,gamma);
res = res*3;

figure('units','normalized','outerposition',[0 0 1 1])
scale = [-0.004 0.004];

subplot(1,1,1), subimage(res,scale);
xlabel('Kilometers','FontSize',14,'FontWeight','normal');
ylabel('Time (Seconds)','FontSize',14,'FontWeight','normal');
ax = gca();
set(ax,'XTick',[50 100 150 200 250])
set(ax,'YTick',[50 100 150 200 250 300])
xticklabel = [50 100 150 200 250]*.0335;
yticklabel = [50 100 150 200 250 300]*.004;
set(ax,'XTickLabel',sprintf('%1.2f|',xticklabel),'FontSize',12,'FontWeight','normal')
set(ax,'YTickLabel',sprintf('%1.2f|',yticklabel),'FontSize',12,'FontWeight','normal')

dlmwrite('Dat/wgPEF12.txt',res,'delimiter','\t','precision',3)

%pause;
close all
