clc
clear all
close all

A = load('Dat/wgstack.txt');
A = A/sqrt(sum(sum(A.*A)));
A = A(1:250,1:200);

s = size(A);

n = 20;
skip = 3;
f = 200/n;
col2interp = zeros(1,skip*n);

count = 0;
for i = 1:n
    for j = 1:skip
        col2interp(1,count+j) = f*i + j - skip;
        A(:,f*i + j - skip) = 0;
    end
    count = count + skip;
end

order = [5 5];
box = [5 5];
gamma = 0.01;

[output,res,status] = streaming_AR_2D_colinterp(A,col2interp,0,order,box,gamma,1);

figure('units','normalized','outerposition',[0 0 1 1])
scale = [-0.004 0.004];

subplot(1,2,1), subimage(A,scale);
xlabel('Kilometers','FontSize',14,'FontWeight','normal');
ylabel('Time (Seconds)','FontSize',14,'FontWeight','normal');
ax = gca();
set(ax,'XTick',[25 75 125 175])
set(ax,'YTick',[50 100 150 200 250 300 350 400 450])
xticklabel = [25 75 125 175]*.0335;
yticklabel = [50 100 150 200 250 300 350 400 450]*.004;
set(ax,'XTickLabel',sprintf('%1.2f|',xticklabel),'FontSize',12,'FontWeight','normal')
set(ax,'YTickLabel',sprintf('%1.2f|',yticklabel),'FontSize',12,'FontWeight','normal')

subplot(1,2,2), subimage(output,scale);
xlabel('Kilometers','FontSize',14,'FontWeight','normal');
ylabel('Time (Seconds)','FontSize',14,'FontWeight','normal');
ax = gca();
set(ax,'XTick',[25 75 125 175])
set(ax,'YTick',[50 100 150 200 250])
xticklabel = [25 75 125 175]*.0335;
yticklabel = [50 100 150 200 250]*.004;
set(ax,'XTickLabel',sprintf('%1.2f|',xticklabel),'FontSize',12,'FontWeight','normal')
set(ax,'YTickLabel',sprintf('%1.2f|',yticklabel),'FontSize',12,'FontWeight','normal')

dlmwrite('Dat/2Dstreaming-holes.txt',A,'delimiter','\t','precision',3)
dlmwrite('Dat/2Dstreaming-interp.txt',output,'delimiter','\t','precision',3)

close all