function [output,phi,res,status] = stationary_AR_1D(input,order)

N = size(input);
if(N(1,2) ~= 1)
    print('Function "stationary_AR_1D" accepts 1D input only. Exiting...');
    status = 1;
    return;
end
N = N(1,1);
p = order;

%Construct D
DT = zeros(N,p);
for i = 1:p
    for j = i:p
        DT(i,j) = input(1,1);
    end
    for j = 1:i-1
        DT(i,j) = input(i-j,1);
    end
end

for i = p+1:N
    for j = 1:p
        DT(i,j) = input(i-j,1);
    end
end

%Least squares solution for phi
DDT = DT'*DT;
phi = DDT\(DT'*input);
output = DT*phi;
res = input - output;
status = 0;

return;

end