% This function performs steepst descent iterations for Ax = b
% Starting vector x0

function [x,r] = steepest_descent(A,b,x0,tol)

% Steepest descent iterations
x = x0;
r = A*x - b;
r_norm = sqrt(r'*r);
t = r_norm;
while(t/r_norm > tol)
    t = r_norm;
    g = A'*r;
    dr = A*g;
    dr_norm = dr'*dr;
    if(dr_norm > tol)
        alpha = -(r'*dr)/(dr'*dr);
    else
        return;
    end
    x = x + alpha*g;
    r = r + alpha*dr;
    r_norm = sqrt(r'*r);
end

end

